/*
**  THIS FILE CONTAINS THE ROUTINES THAT DETERMINE
**  THE SYNTAX OF THE KAWK LANGUAGE; KEY WORDS
**  ARE IN KA.COMP2.C
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include    "kawkfunc.h"
/*DEFINE*/
#define		SIMPLE	1
#define		ARRAY	2
#define		POINT	3
static		FUNCP	assfunc;
/*TYPEDEF*/
typedef	struct	STATE	{
		char	*sname;
		char	slent;
		char	*(*sfunc)();
		char	soff;
		char	styp;
	}	STATE;
typedef	struct	CLIST	{
	char	*cn;
	int		cv;
	}	CLIST;
typedef	struct	ASSCOMP	{
	char	*an;
	FUNCP	fu;
	}	ASSCOMP;
typedef	struct	TOKEN	{
	char	*tp;		/* token pattern */
	FUNCP	pr;			/* pattern finding routine */
	int		sc;			/* characters to check */
	int		sk;			/* characters to skip */
	char	*(*cr)();	/* compiling routine */
	char	*fn;		/* function name */
	}	TOKEN;
/*EXTERNAL*/
#ifdef	CAN_PROTO
extern void aemod(void);
extern void aemul(void);
extern void aediv(void);
extern void aesub(void);
extern void aeadd(void);
extern void xswap(void);
extern CLIST *isconst(char *);
extern CLIST *iscont(char *);
#else
extern void aemod();
extern void aemul();
extern void aediv();
extern void aesub();
extern void aeadd();
extern void xswap();
extern CLIST *isconst();
extern CLIST *iscont();
#endif
/*GLOBAL*/
TOKEN	token[] = {
	"-=",hasnstr,2,0,NULL,"NULL",
	"++",hasnstr,2,0,NULL,"NULL",
	"--",hasnstr,2,0,NULL,"NULL",
	"(float)",hasnstr,7,7,floatcomp,"floatcomp",
	"(int)",hasnstr,5,5,intcomp,"intcomp",
	"(",hasnstr,1,1,parencomp,"parencomp",
	"BUFSIZ", 	hasnstr, 6, 0, constcomp, "constcomp",
	"EOF",		hasnstr, 3, 0, constcomp, "constcomp",
	"FNMSIZ", 	hasnstr, 6, 0, constcomp, "constcomp",
	"FUBAR", 	hasnstr, 5, 0, constcomp, "constcomp",
	"NO", 		hasnstr, 2, 0, constcomp, "constcomp",
	"NULL", 	hasnstr, 4, 0, constcomp, "constcomp",
	"YES", 		hasnstr, 3, 0, constcomp, "constcomp",
	"ZERO",		hasnstr, 4, 0, constcomp, "constcomp",
	"$",hasnstr,1,0,keycomp,"keycomp",
	"'",hasnstr,1,0,charcomp,"charcomp",
	"\"",hasnstr,1,0,strcomp,"strcomp",
	"~",hasnstr,1,1,onescomp,"onescomp",
	"-",hasnstr,1,1,umcomp,"umcomp",
	"!",hasnstr,1,1,lncomp,"lncomp",
	NULL,is_sym,0,0,symcomp,"symcomp",
	NULL,is_con,0,0,constcomp,"constcomp",
	}	;
static	int	tsize = sizeof(token)/sizeof(TOKEN);
ASSCOMP	assc[] = {
	"+=",	(FUNCP)	aeadd,
	"-=",	(FUNCP)	aesub,
	"*=",	(FUNCP)	aemul,
	"/=",	(FUNCP)	aediv,
	"%=",	(FUNCP)	aemod,
	}	;
int	asize = sizeof(assc)/sizeof(ASSCOMP);
CLIST	clist[] = {
/*	
	this list most be duplicated with suitable changes in
	TOKEN to allow for all possible occurences
*/
	"BUFSIZ", BLKSIZ,
	"EOF", EOF,
	"FNMSIZ", FNMSIZ,
	"FUBAR", FUBAR,
	"NO",NO,
	"NULL", ZERO,
	"YES",YES,
	"ZERO", ZERO,
	}	;
STATE	st[] = {
	"break", 5, breakcomp, 5, ZERO,
	"char", 4, defncomp, 4, VCHAR,
	"continue", 8, contcomp, 8, ZERO,
	"double", 6, defncomp, 6, VDOUBLE,
	"else", 4, ifcomp, 0, ZERO,
	"float", 5, defncomp, 5, VFLOAT,
	"for", 3, forcomp, 3, ZERO,
	"if", 2, ifcomp, 2, ZERO,
	"int", 3, defncomp, 3, VINT,
	"long", 4, defncomp, 4, VLONG,
	"main()", 6, statecomp, 6, ZERO,
	"while", 5, whilecomp, 5, ZERO,
	"{", 1, compcomp, 1, ZERO,
	}	;
STATE	*stb = st;
STATE	*stu = st + (sizeof(st)/sizeof(STATE));
/**/
/**/
CLIST	*
iscont(is)
char	*is;
{
	REG		CLIST	*clx = clist;
	REG		CLIST	*clu = clist + (sizeof(clist) / sizeof(CLIST));
	while(clx < clu)	{
		if(strncmp(is,clx->cn,strlen(clx->cn)) == 0) return(clx);
		clx += 1;
		}
	return((CLIST *) NULL);
}
char    *
compcomp(is)    /* COMPOUND EXPRESSION */
char    *is;
{
	auto	char	*isx = is;
	auto	char	*lpx;
	auto	char	*hdx = lpxretr();
/**/
	bracket += 1;
/**/
	while( (int) (isx = statecomp(lpx = skipbs(isx)))	)	{
		if(*isx == RCB)	{
			bracket -= 1;
#ifdef	XSTACK
			addcode( (INST) xstack,"xstack");
#endif
			return(skipbs(++isx));
			}
		if(lpx == isx)	{
			break;
			}
		}
/**/
	lpxsetr(hdx);
	errptr(hdx,"compcomp <bracket mismatch>");
/**/
	return(NULL);
}
/**/
char	*
findst(is)
char	*is;
{
	REG		STATE	*stx = stb;
	REG		char	*isx = skipbs(is);
	while(stx < stu)	{
		if(isstate(isx,stx->sname,stx->slent))	{
			isx = skipbs((*stx->sfunc)(isx + stx->soff, stx->styp));
			return(isx);
			}
		else	++stx;
		}
	return(NULL);
}
isstate(os,is,nis)
char	*os;		/* string being parsed */
char	*is;		/* target string */
int		nis;		/* length of target string */
{
	auto	int		ret;
	if(*os == *is && *is == LCB)	return(ret = 1);
	ret = ((strncmp(os,is,nis) == 0) && !isalnum(os[nis])) ? 1 : 0;
	return(ret);
}
/**/
char    *
statecomp(is)	/* compile a statement */
char    *is;
{
/**/
	auto	char	*isx = NULL;
/**/
    if(isnull(is))                      return(NULL);
/**/
	if((int) (isx = findst(is)))				return(isx);
/**/
    is = skipbs(exprcomp(is));
/**/
    if(*is == ';') {
        is += 1;
        addcode( (INST) xstack,"xstack");
        }
/**/
    return(skipbs(is));
}
char    *
exprcomp(is)        /* COMPILE AN EXPRESSION */
char    *is;
{
/*
**  lowest precedence item goes here
**  it calls next highest, and so on
*/
	return(questcomp(is));
}
void
xquest()
{
	auto	INST	*p0;
	auto	INST	*p1;
	auto	INST	*p2;
	p0 = prx++;
	p1 = prx++;
	p2 = prx++;
	ds = epop();
	if(ds.v.ivalu)	xecute( (INST *) *p0 );
	else			xecute( (INST *) *p1 );
	prx = (INST *)	*p2;
}
char	*
questcomp(is)	/* expr ? expr : expr */
char	*is;
{
	auto	char	*isx;
	auto	INST	*p0;
	auto	INST	*p1;
	auto	INST	*p2;
	isx = lorcomp(isx = is);
	while(skipbs(isx) && *isx != ZERO)	{
	if(*isx == '?')	{
		addcode( (FUNCP) xdtol,"xdtol");
        addcode( (FUNCP) xquest,"xquest");
        p0 = addcode(XSTOP,"jump");
        p1 = addcode(XSTOP,"jump");
        p2 = addcode(XSTOP,"jump");
		*p0 = (INST) retrcode();
		isx = lorcomp(++isx);	/* ? part */
        addcode(XSTOP,"XSTOP");
		if(*isx != ':')
			errptr(is,"questcomp <missing :>");
		*p1 = (INST) retrcode();
		isx = lorcomp(++isx);	/* : part */
        addcode(XSTOP,"XSTOP");
		*p2 = (INST) retrcode();
		}
	else	break;
	}
	return(skipbs(isx));
}
char    *
constcomp(is)   /* numerical constant */
char    *is;
{
    auto    SYMBOL  *sym;
	auto	CLIST	*clx;
    REG     char    *isx = is;
    auto    int     ivalu;
	auto	double	dvalu;
	auto	int		ty = VINT;
/**/
	if((int)(clx = iscont(isx)))	{
		ivalu = clx->cv;
		isx += strlen(clx->cn);
		}
    else    {
        ivalu = atoi(isx);
		dvalu = atof(isx);
		if(dvalu > (double) ivalu)	ty = VDOUBLE;
		isx = digiskip(isx);
        }
/**/
    addcode( (INST) xconst,"xconst");
/**/
	if(ty == VDOUBLE)	{		
		auto	double	*dp;
		dp = (double *) emalloc(sizeof(double),"constcomp");
		*dp = dvalu;
    	sym = addsym(NULL,ty,(char *) dp,sizeof(double),0,(FUNCP) NULL);
		}
	else
	if(ty == VINT)		{
		auto	int		*np;
		np = (int *) emalloc(sizeof(int),"constcomp");
		*np = ivalu;
    	sym = addsym(NULL,ty,(char *) np,sizeof(int),0,(FUNCP) NULL);
		}
/**/
    symcode((INST) sym, "CONSTANT");
/**/
    return(skipbs(isx));
}
char    *
charcomp(is)    /* CHARACTER CONSTANT */
char    *is;
{
#define		APOST	'\''
#define		MCCSS	16
    auto    SYMBOL  *sym = NULL;
	auto	char	ws[MCCSS];
	auto	int		*cc;
/*
	'a'
	'\000'
*/
	is = xgnc(ws,ws+MCCSS-1,is+1,*is);
/**/
	xesc(ws);
/**/
    addcode( (INST) xconst,"CHAR");
/**/
    cc = (int *) 	emalloc(sizeof(int),"charconst");
/**/
	*cc = (int) ws[0];
/**/
    sym = addsym(NULL,VINT,(POINTER) cc,sizeof(int),0, (FUNCP) NULL);
/**/
    symcode((INST) sym, "CHAR");
/**/
    return(skipbs(is));
}
char    *
symcomp(is)     /* VARIABLE */
char    *is;
{
	auto	FUNCP	fu = (FUNCP) NULL;
    auto    SYMBOL  *sym = NULL;
    REG     char    *isx = is;
    REG     char    *nme = NULL;
/**/
    isx = namepull(isx);
    nme = nameretr();
/**/
    if(strncmp(isx,"++",2) == 0 ||
        strncmp(isx,"--",2) == 0)
            errptr(isx,"tokencomp <not implemented>");
/**/
	fu = isbuiltin(nme);
	if(fu != (FUNCP) NULL)	{
		isx = funccomp(isx,fu,nme);
		return(isx);
		}
/**/
    if(!(sym = retrsym(nme)))
        errptr(is,"symcomp <undefined symbol>");
/**/
	if(sym->tsize > 1)		return(arraycomp(isx,sym));
	else
    if(*isx == '[')     	return(arraycomp(isx,sym));
    else                	return(assgncomp(isx,sym,SIMPLE));
}
/**/
isassign(is)
char	*is;
{
	REG		ASSCOMP	*asx = assc;
	REG		ASSCOMP	*asu = assc + asize;
	assfunc = (FUNCP) NULL;
	if(strncmp(is,"==",2) == 0)	return(0);
	else
	if(strncmp(is,"=",1) == 0)	{
		assfunc = xassgn;
		return(1);
		}
	while(asx < asu)	{
		if(strncmp(asx->an,is,2) == 0)	{
				assfunc = asx->fu;
#ifdef	DEBUG
fprintf(stderr,"isassign(%s)\n",asx->an);
query(stderr);
#endif	/*DEBUG*/
				return(2);
				}
		else	{
			asx += 1;
			}
		}
	return(0);
}
/**/
char    *
keycomp(is)             /* COMPILE A KEY CALL */
char    *is;
{
    REG     char    *isx = is +1;
    auto    char    *nme = NULL;
    auto    int     nk;
    if(!kenv.keying)    errptr(is,"keycomp <no keys>");
    isx = namepull(isx);
    nme = nameretr();
    nk = iskey(nme);
    if(nk < 0)          errptr(is,"keycomp <unknown key>");
    if(*isx == '=')     errptr(isx,"keycomp <assign to key>");
    addcode( (INST) xkey,"xkey");
    addcode((INST) nk, "KEY_NUMBER");
    return(isx);
}
char    *
arraycomp(is,sym)       /* COMPILE INDEX FOR ARRAYS */
SYMBOL  *sym;
char    *is;
{
    auto	char    *isx = is;
	auto	int		ty = ARRAY;
/**/
    if(sym->tsize <= 1) errptr(isx,"arraycomp <not an array>");
/**/
    if(*isx == '[') {
        isx = exprcomp(skipbs(++isx));
        if(*isx != ']') errptr(is,"arraycomp <subscript syntax>");
        isx = skipbs(++isx);
        if(*isx == '[') errptr(is,"arraycomp <too many subscripts>");
		ty = ARRAY;
        }
	else	ty = POINT;
    return(assgncomp(skipbs(isx),sym,ty));
}
char    *
assgncomp(is,sym,ty)   /* COMPILE ASSIGNMENT CODE */
char    *is;
SYMBOL  *sym;
NOSIGN	ty;
{
    auto    char    *isx = is;
	auto	int		assign = isassign(isx);
	auto	FUNCP	fus = assfunc;
/**/
#ifdef	DEBUG
fprintf(stderr,"0assgncomp(%d)\n",assign);
#endif	/*DEBUG*/
    if(assign)    {
		isx = exprcomp(isx + assign);
		}
#ifdef	DEBUG
fprintf(stderr,"1assgncomp(%d)\n",assign);
#endif	/*DEBUG*/
/**/
	if(ty == ARRAY && assign)	
					symcode((INST) xswap,"xswap");
/**/
	addcode((INST) xsym,"xsym");
	symcode((INST) sym,sym->name);
/**/
	if(ty == POINT)	symcode((INST) xpoint,"xpoint");
	else
	if(ty == ARRAY)	symcode((INST) xarray,"xarray");
/**/
#ifdef	DEBUG
fprintf(stderr,"assign(%d)\n",assign);
#endif	/*DEBUG*/
	if(assign)		{
#ifdef	DEBUG
fprintf(stderr,"assign(%d)\n",assign);
query(stderr);
#endif	/*DEBUG*/
		if(assign == 2)	{
			addcode((INST) fus,"math assign");
			}
		addcode((INST) xassgn,"xassgn");
		}
	else	{
		if(ty != POINT) addcode((INST) xeval, "xeval");
		}
/**/
	return(skipbs(isx));
}
char    *
funccomp(is,fu,os) 	/* COMPILE A FUNCTION CALL */
char    *is;		/* more text */
FUNCP	fu;			/* built in function to call */
char	*os;		/* name of function */
{
    auto    INST    *p0;
    auto    INST    *p1;
    REG     char    *isx = is + 1;
    REG     int     param = 0;
    REG     char    *lst = NULL;
/**
**  0       xfunc
**  1       pointer to function
**  2       argument count
**  3       pointer to code after function
**  expr1
**  expr2
**  exprN
**  next code
*/
/**/
    addcode( (INST) xfunc,"xfunc");
	addcode( fu, os );
/**/
    p0 = addcode( (INST) XSTOP,"XSTOP");
    p1 = addcode( (INST) XSTOP,"XSTOP");
/**/
    while((int) (lst != isx)
		&& (int) (isx = exprcomp(lst = skipbs(isx))) && *isx != ZERO)
        if(*isx == ')')     {
/**/
            if(retrcode() != p1 + 1)    param += 1;
            addcode( (INST) XSTOP,"XSTOP");
/**/
            *p0 = (INST) param;
            *p1 = (INST) retrcode();
/**/
			if(paramchk(fu,param))	break;
/**/
            return(skipbs(++isx));
            }
        else
        if(*isx == ',')     {
            param += 1;
            isx += 1;
            }
        else				{
        	break;
			}
/**/
    errptr(is,"funccomp <bad function call>");
/**/
    return(NULL);
}
char    *
tokencomp(is)       /* COMPILE TOKENS */
char    *is;
{
	REG		TOKEN	*tkx = token;
	REG		TOKEN	*tku = token + tsize;
    auto	char    *isx = is;
    isx = skipbs(isx);
	while(tkx < tku)	{
		if((*tkx->pr)(isx,tkx->tp,tkx->sc))	{
			if(*tkx->cr)	{
				isx = (*tkx->cr)(isx + tkx->sk);
				}
			break;
			}
		tkx += 1;
		}
	return(skipbs(isx));
}
