#define		DEBUG
#undef		DEBUG
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
#define     MAXFORM     16
/**/
int			db_printf = NO;
/**/
/*EXTERN*/
/*STATIC*/
static      char    *ws = NULL;
static      char    *wsu = NULL;
static      char    *wsx = NULL;
/**/
char    *
setwork(nc)     /* set work space */
NOSIGN	nc;
{
	ws = free_if(ws);
    if(!(ws = emalloc(nc,"setwork"))) terror(FUBAR);
    wsx = ws;
    wsu = ws + nc - (nc / 10);
    return(ws);
}
void
ksetwork(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = setwork(ap[0].v.ivalu);
    pusher = spush;
}
setfold(nc)
NOSIGN	nc;
{
    return(kenv.folder = nc);
}
void
ksetfold(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = setfold(ap[0].v.ivalu);
    pusher = ipush;
}
void
kputline(na,ap,wf,eol)
int		na;			/* arg num */
DATUM	*ap;		/* arg vec */
FUNCP	wf;			/* write function */
char	*eol;		/* line termination */
{
	auto	char	*is = ap[0].v.ptr;
	auto	FILE	*wfp = ofp;
	auto	int		fold = kenv.folder;
/**/
	if(na > 1)		wfp = (FILE *) ap[1].v.ivalu;
	if(na > 2)		fold = ap[2].v.ivalu;
/**/
#ifdef	DEBUG
	{
	fprintf(stderr,"ap(%u) ",ap);
	switch(ap->vtype)	{
		case	'c':	fprintf(stderr,"%c %o",ap->vtype,ap->v.ivalu);
		when	'd':	fprintf(stderr,"%c %d",ap->vtype,ap->v.dvalu);
		when	'i':	fprintf(stderr,"%c %d",ap->vtype,ap->v.ivalu);
		when	's':	fprintf(stderr,"%c %s",ap->vtype,ap->v.ptr);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
	}
#endif
#ifdef	DEBUG
	fprintf(stderr,"na(%u) ",na);
	fprintf(stderr,"is(%u) (%s) ",is,is);
	fprintf(stderr,"wfp(%u) stdout(%u) ",wfp,stdout);
	fprintf(stderr,"fold(%u) ",fold);
	if(eol)	fprintf(stderr,"eol(%u) ",eol);
	fprintf(stderr,"\n");
#endif
	(*wf)(is,wfp,fold);
	rdx.v.ptr = is;
	if(eol)	fputs(eol,wfp);
	pusher = spush;
}
void
kputs(na,ap)
int     na;
DATUM   *ap;
{
#ifdef	DEBUG
	{
	fprintf(stderr,"ap(%u) ",ap);
	switch(ap->vtype)	{
		case	'c':	fprintf(stderr,"%c %o",ap->vtype,ap->v.ivalu);
		when	'd':	fprintf(stderr,"%c %d",ap->vtype,ap->v.dvalu);
		when	'i':	fprintf(stderr,"%c %d",ap->vtype,ap->v.ivalu);
		when	's':	fprintf(stderr,"%c %s",ap->vtype,ap->v.ptr);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
	}
#endif
	kputline(na,ap,(FUNCP) fputs,"\n");
}
void
kputsf(na,ap)
int     na;
DATUM   *ap;
{
	kputline(na,ap,(FUNCP) fputlf,NULL);
}
void
kfputs(na,ap)
int     na;
DATUM   *ap;
{
	kputline(na,ap,(FUNCP) fputs,NULL);
}
void
ksformat(na,ap)  /* format output to string */
int     na;
DATUM   *ap;
{
    rdx.v.ptr = format(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,na-2,ap+2);
    pusher = spush;
}
void
kprint(na,ap)       /* format output to stderr */
int     na;
DATUM   *ap;
{
    format(ws,wsu,na,ap);
    if(kenv.folder)         fputlf(rdx.v.ptr = ws,stderr,kenv.folder);
    else                    fputs(rdx.v.ptr = ws,stderr);
    pusher = spush;
}
void
kfprintf(na,ap)      /* format output to output file */
int     na;
DATUM   *ap;
{
	auto	FILE	*fp = (FILE*) ap[0].v.ivalu;
#ifdef	DEBUG
	fputs("kprintf ");
	fprintf(stderr,
		"pusher(%u) spush(%u) ipush(%u) dpush(%u) rdx(%u)\n",
			pusher,spush,ipush,dpush,&rdx);
#endif
    format(ws,wsu,na-1,ap+1);
    if(kenv.folder)         fputlf(rdx.v.ptr = ws,fp,kenv.folder);
    else                    fputs(rdx.v.ptr = ws,fp);
#ifdef	DEBUG
	fputs("kprintf ");
	fprintf(stderr,
		"pusher(%u) spush(%u) ipush(%u) dpush(%u) rdx(%u)\n",
			pusher,spush,ipush,dpush,&rdx);
#endif
    pusher = spush;
}
void
kprintf(na,ap)      /* format output to output file */
int     na;
DATUM   *ap;
{
/**/
#ifdef	DEBUG
	{
	fprintf(stderr,"ap(%u) ",ap);
	switch(ap->vtype)	{
		case	'c':	fprintf(stderr,"%c %o",ap->vtype,ap->v.ivalu);
		when	'd':	fprintf(stderr,"%c %d",ap->vtype,ap->v.dvalu);
		when	'i':	fprintf(stderr,"%c %d",ap->vtype,ap->v.ivalu);
		when	's':	fprintf(stderr,"%c %s",ap->vtype,ap->v.ptr);
						break;
		default:		fprintf(stderr,"?");
		}
	fprintf(stderr,"\n");
	}
#endif
    format(ws,wsu,na,ap);
#ifdef	DEBUG
	fputs("<<",ofp);
#endif
    if(kenv.folder)         fputlf(rdx.v.ptr = ws,ofp,kenv.folder);
    else                    fputs(rdx.v.ptr = ws,ofp);
#ifdef	DEBUG
	fputs(">>",ofp);
	fflush(ofp);
#endif
    pusher = spush;
}
char    *
format(os,us,na,ap)
char    *os;        /* output area */
char    *us;        /* upper limit of os */
int		na;	    	/* number of arguments */
DATUM   *ap;        /* argument pointer */
{
    auto    char    fs[MAXFORM];
    auto    char    *fsave = ZERO;
    REG     char    *osx = os;
    REG     char    *usx = us;
    REG     char    *fmt = ap[0].v.ptr;
    REG     char    cx;
	ap += 1;
    na -= 1;        /* format is one argument */
    fsave = fmt;
    *os = ZERO;
#ifdef	DEBUG
	fprintf(stderr,"format: fmt(%s)\n",fmt);
#endif
    while(osx < usx && (cx = *fmt++) != ZERO)
    if(cx == '%')
        switch(*fmt)
        {
        case    'q':    *osx++ = '\'';
                        fmt++;
        when    '%':    *osx++ = *fmt++;
        when    'Q':    *osx++ = '"';
                        fmt++;
        when    'P':    osx = strkat(osx,usx,"\\fP");
                        fmt++;
        when    'I':    osx = strkat(osx,usx,"\\fI");
                        fmt++;
        when    'R':    osx = strkat(osx,usx,"\\fR");
                        fmt++;
        when    'B':    osx = strkat(osx,usx,"\\fB");
                        fmt++;
        when    'n':
        case    'N':    *osx++ = '\n';
                        fmt++;
        when    'S':    if(na <= 0) {
                            errmsg("format <too few arguments> (%s)\n",fsave);
                            terror(FUBAR);
                            }
                        if(ap[0].v.ptr == NULL) 
                        ap += 1;
                        else    
                        osx = strkat(osx,usx,strfold(ap[0].v.ptr,kenv.folder));
						ap += 1;
                        na -= 1;
                        fmt++;
                        break;
/**/
        default:        
                        if(na <= 0) {
                            errmsg("format <too few arguments> (%s)\n",fsave);
                            terror(FUBAR);
                            }
                        fmt = fmtpull(fs,&fs[MAXFORM-1],fmt);
                        osx = fmtaddr(osx,usx,fs,*fmt++,ap);
                        ap += 1;
                        na -= 1;
                        break;
        }
    else    {
        *osx++ = cx;
        }
    *osx = ZERO;
    if(osx >= usx)
        {
        errmsg("format <long line> os %u usx %u %u %u\n",
			os,usx,usx-os,strlen(os));
        fputs(os,stderr);
        fputc('\n',stderr);
        terror(FUBAR);
        }
    if(na >= 1) {
        errmsg("format <too many arguments> (%s)\n",fsave);
        terror(FUBAR);
        }
    return(osx);
}
char    *
fmtaddr(os,us,fs,vt,ap)
char    *os;        /* output string */
char    *us;        /* upper limit of os */
char    *fs;        /* format */
NOSIGN	vt;		/* variable type */
DATUM   *ap;        /* argument pointer */
{
    auto    char    *osx = os;
    switch(vt)  {
    case    'c':
    case    'd':
    case    'u':
	case	'x':
    case    'o':    if(ap[0].vtype == VDOUBLE)
						fmterr("integer","double");
					sprintf(os,fs,ap[0].v.ivalu);
					break;
	case	'e':
    case    'f':
    case    'g':    if(ap[0].vtype != VDOUBLE)
						fmterr("double","integer");
					sprintf(os,fs,ap[0].v.dvalu);
					break;
    case    's':    if(ap[0].vtype == VDOUBLE)	
						fmterr("double","string");
					if(isnull(ap[0].v.ptr))		os[0] = ZERO;
					else						sprintf(os,fs,ap[0].v.ptr);
                    break;
    default:        errmsg("fmtaddr <bad format> (%s)\n",fs);
                    terror(FUBAR);
                    break;
    }
    osx += strlen(osx);
    if(osx >= us)   {
        errmsg("fmtaddr <overflow>\n");
        fputs(os,stderr);
        fputc('\n',stderr);
        terror(FUBAR);
        }
    return(osx);
}
fmterr(os,is)
char	*os;
char	*is;
{
	errmsg("fmterr <attempt to print %s as %s>\n",os,is);
	terror(FUBAR);
}
char    *
fmtpull(os,us,is)       /* pull the format specification */
char    *os;
char    *us;
char    *is;
{
    REG     char    *isx = is;
    REG     char    *osx = os;
    REG     char    *usx = us - 1;
    *osx++ = '%';
    while(osx < usx && *isx != ZERO && !isalpha(*isx))
        *osx++ = *isx++;
    if(!isalpha(*isx) || osx >= usx)    {
        *osx = ZERO;
        errmsg("fmtpull <bad format> (%s)\n");
        terror(FUBAR);
        }
    *osx++ = *isx;
    *osx++ = ZERO;
    return(isx);
}
