#include	<stdio.h>
#include	<ctype.h>
#define		ZERO	0
/*TYPEDEF*/
typedef	char	*	CODE;
typedef	struct	KEYWORD	{
	char	*kname;
	char	ksize;
	char	ktype;
	int		(*kfunc)();
	}	KEYWORD;
/*EXTERN*/
extern	char	*pexpr(char *);
extern	KEYWORD	*iskeyword(char *, int, char *);
extern	char	*variable(char *);
extern	char	*skipbs(char *);
extern	char	*value(char *);
extern	char	*relate(char *);
extern	char	*equals(char *);
extern	char	*logind(char *);
extern	char	*logior(char *);
extern	char	*muldiv(char *);
extern	char	*addsub(char *);
extern	char	*assign(char *);
extern	char	*statement(char *);
extern	char	*compile(char *);
extern	char	*expr(char *);
extern	CODE	*pinst(char *);
extern	CODE	*ginst(void);
extern	CODE	*sinst(void);
extern	char	*co_while(char *);
extern	char	*co_for(char *);
/*GLOBAL*/
CODE	code[BUFSIZ];
CODE	*cdx;
#define	CO_LOOPER	1
#define	CO_COMMAS	2
#define	CO_SEMICO	3
#define	CO_ASSIGN	4
#define	CO_LOGIOR	5
#define	CO_LOGIND	6
#define	CO_EQUALS	7
#define	CO_RELATE	8
#define	CO_ADDSUB	9
#define	CO_MULDIV	10
KEYWORD	keylist[] = {
	"while(",	6,	CO_LOOPER,		co_while,
	"for(",		4,	CO_LOOPER,		co_for,
	",",	1,	CO_COMMAS,		(int (*)()) NULL,
	";",	1,	CO_SEMICO,		(int (*)()) NULL,
	"=",	1,	CO_ASSIGN,		(int (*)())	NULL,
	"||",	2,	CO_LOGIOR,		(int (*)())	NULL,
	"&&",	2,	CO_LOGIND,		(int (*)())	NULL,
	"==",	2,	CO_EQUALS,		(int (*)())	NULL,
	"!=",	2,	CO_EQUALS,		(int (*)())	NULL,
	"<=",	2,	CO_RELATE,		(int (*)())	NULL,
	">=",	2,	CO_RELATE,		(int (*)())	NULL,
	"<",	1,	CO_RELATE,		(int (*)())	NULL,
	">",	1,	CO_RELATE,		(int (*)())	NULL,
	"+",	1,	CO_ADDSUB,		(int (*)())	NULL,
	"-",	1,	CO_ADDSUB,		(int (*)())	NULL,
	"%",	1,	CO_MULDIV,		(int (*)())	NULL,
	"*",	1,	CO_MULDIV,		(int (*)())	NULL,
	"/",	1,	CO_MULDIV,		(int (*)())	NULL,
	NULL,	0,	0,				(int (*)())	NULL,
	}	;
char	ls[BUFSIZ];
int		tracer;
main()
{
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
	case	'#':	tracer = !tracer;
					break;
	case	'!':	system(ls+1);
					break;
	default:		compile(ls);
					break;
	}
}
linst()		/* list instruction code */
{
	auto	CODE	*cdp = code;
	while(cdp < cdx)	{
		printf("%3d %s\n",cdp-code,*cdp);
		cdp += 1;
		}
}
CODE	*
sinst()		/* initialize instruction code */
{
	return( cdx = code );
}
CODE	*
pinst(is)	/* push instruction code */
char	*is;	
{
	return( *cdx++ = strdup(is) );
}
CODE	*
ginst()		/* get instruction code */
{
	return( *--cdx );
}
KEYWORD	*
iskeyword(is,ty,os)
char	*is;
int		ty;
char	*os;
{
	auto	KEYWORD	*kwx = keylist;
#ifdef	TRACE
	static	char	*here = "iskeyword";
	if(tracer)	printf("%s: is(%s) ty(%d) os(%s)\n",here,is,ty,os);
#endif
	while(kwx->kname)	{
		if(kwx->ktype == ty &&
			strncmp(is,kwx->kname,kwx->ksize) == 0)	{
				return(kwx);
				}
		kwx += 1;
		}
	return( (KEYWORD *) NULL );
}
char	*
compile(is)
char	*is;
{
	static	char	*here = "compile";
	auto	KEYWORD	*kwx;
#ifdef	TRACE
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	sinst();
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_LOOPER,here))	{
			is = (*kwx->kfunc)(skipbs(is + kwx->ksize));
			}
		else	is = statement(is);
		}
	linst();
}
char	*
co_for(is)		/* compile for statement */
char	*is;
{
#ifdef	TRACE
	static	char	*here = "co_while";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	pinst("for()");
	is = expr(is);		/* pre-loop portion */
	pinst("for: a");
	is = expr(is);		/* conditional portion */
	pinst("for: b");
	is = expr(is);		/* post-loop portion */
	pinst("for: c");
	is = statement(is);	/* executable statement */
	return(is);
}
char	*
co_while(is)	/* compile while statement */
char	*is;
{
#ifdef	TRACE
	static	char	*here = "co_while";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	pinst("while()");
	is = expr(is);		/* conditional portion */
	pinst("while{}");
	is = statement(is);	/* executable portion */
	pinst("while: stop");
	return(is);
}
char	*
statement(is)
char	*is;
{
#ifdef	TRACE
	static	char	*here = "statement";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	return(expr(is));
}
char	*
expr(is)
char	*is;
{
	auto	char	*os;
#ifdef	TRACE
	static	char	*here = "expr";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	while(*is != ZERO)	{
		is = assign(os = is);
		if(*is == ')')	{
			break;
			}
		else
		if(*is == ',')	{
			pinst(*is++);
			continue;
			}
		else
		if(*is == ';')	{
			pinst(*is++);
			break;
			}
		else
		if(is == os)	{
			fprintf(stderr,"\007<loop> '%s'\n",os);
			return(NULL);
			}
		}
	return(skipbs(is));
}
char	*
assign(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = logior;
#ifdef	TRACE
	static	char	*here = "assign";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_ASSIGN,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
logior(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = logind;
#ifdef	TRACE
	static	char	*here = "logior";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_LOGIOR,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
logind(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = equals;
#ifdef	TRACE
	static	char	*here = "logind";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_EQUALS,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
equals(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = relate;
#ifdef	TRACE
	static	char	*here = "equals";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_EQUALS,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
relate(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = addsub;
#ifdef	TRACE
	static	char	*here = "relate";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_EQUALS,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
addsub(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = muldiv;
#ifdef	TRACE
	static	char	*here = "addsub";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_ADDSUB,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
muldiv(is)
char	*is;
{
	auto	KEYWORD	*kwx;
	auto	char	*(*fu)() = value;
#ifdef	TRACE
	static	char	*here = "muldiv";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = (*fu)(is);
	while(is && *is)	{
		if(kwx = iskeyword(is,CO_MULDIV,here))	{
			is = (*fu)(is + kwx->ksize);
			printf("%s\n",kwx->kname);
			pinst(kwx->kname);
			}
		else	break;
		}
	return(is);
}
char	*
value(is)
char	*is;
{
#ifdef	TRACE
	static	char	*here = "value";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = skipbs(is);
	if(isalpha(*is))	is = variable(is);
	else
	if(*is == '(')		is = pexpr(++is);
	return(skipbs(is));
}
char	*
pexpr(is)
char	*is;
{
	auto	char	*os = is;
#ifdef	TRACE
	static	char	*here = "pexpr";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	is = expr(is);
	if(*is != ')')	{
		fprintf(stderr,"<missing paren>\n");
		return(NULL);
		}
	return(skipbs(++is));
}
char	*
skipbs(is)
char	*is;
{
#ifdef	TRACER
	static	char	*here = "skipbs";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	while(isspace(*is))	++is;
	return(is);
}
char	*
variable(is)
char	*is;
{
	auto	char	vn[32];
	auto	char	*vx = vn;
#ifdef	TRACE
	static	char	*here = "variable";
	if(tracer)	printf("%s: is(%s)\n",here,is);
#endif
	while(isalpha(*is) || *is == '_')	*vx++ = *is++;
	*vx = ZERO;
	printf("%s\n",vn);
	pinst(vn);
	is = skipbs(is);
	return(is);
}
