/*
|	service routines for pdtar, mostly items from the kinmonth
|	library given here to allow independent compilation.
*/
#include	"pdtar.h"
#include	"pdproto.h"
FILE *
efopen(fn,mo,wh)	/* open with error message */
char	*fn;		/* file name */
char	*mo;		/* mode */
char	*wh;		/* caller */
{
	auto	FILE	*fp = fopen(fn,mo);
	if(fp == (FILE *) NULL)	{
		where(wh);
		fprintf(stderr,"<could not open> '%s' for '%s'\n",fn,mo);
		perror(fn);
		}
	return(fp);
}
char	*
digiskip(is)
char	*is;
{
	while(isdigit(*is))	++is;
	return(is);
}
where(is)
char	*is;
{
	if(stdout)	fflush(stdout);
	if(stdrpt)	fflush(stdrpt);
	fputs("\007\007",stderr);
	fputs("pdtar: ",stderr);
	fputs("(",stderr);
	fputs(is,stderr);
	fputs(") ",stderr);
	return(0);
}
badstat(os,sp,is)
char	*os;	/* file name */
STAT	*sp;	/* stat pointer */
char	*is;	/* message string */
{
	if(stat(os,sp) < 0)	{
		where(is);
		perror(os);
		return(-1);
		}
	return(0);
}
char	*
strcnd(is)		/* cleanup a string */
char	*is;
{
	auto	char	*isx = is;
	auto	char	*osx = is;
	while(isspace(*isx))	++isx;
	while(*isx != 0)
	if(isspace(*isx))	{
		while(isspace(*isx))	++isx;
		if(*isx != 0)	*osx++ = ' ';
		}
	else	*osx++ = *isx++;
	*osx = 0;
	return(is);
}
char	*
strxty(is,cx,cy)	/* changes case of cx to cy in is */
char	*is;
int		cx;
int		cy;
{
	register	char	*isx;
	for(isx = is; *isx != 0; isx++)	{
		if(*isx == (char) cx)	*isx = (char) cy;
		}
	return(isx);
}
long
cal_bif(size)		/* blocks in file */
long	size;
{
	auto	long	bif;
	auto	long	blk = (long) BLKSIZ;
	bif = size / blk;
	bif = (size % blk) ? (bif + 1) : bif;
	return(bif);
}
strnicmp(os,is,nc)	/* compare strings, ignore case */
char	*os;
char	*is;
int		nc;
{
	register	char	*osx = os;
	register	char	*isx = is;
	register	int		ncx = nc;
	while(*osx != 0 && (ncx-- >= 1) &&
		tolower(*osx) == tolower(*isx))	++osx, ++isx;
	return(tolower(*osx) - tolower(*isx));
}
stricmp(os,is)	/* compare strings, ignore case */
char	*os;
char	*is;
{
	register	char	*osx = os;
	register	char	*isx = is;
	while(*osx != 0 && tolower(*osx) == tolower(*isx))	++osx, ++isx;
	return(tolower(*osx) - tolower(*isx));
}
char	*
maketemp(is)
char	*is;
{
	static		int		pid = 0;
	static		int		cc = 0;
	auto		char	id[NAMSIZ];
	auto		char	ws[NAMSIZ];
	auto		char	*xs;
/**/
	xs = strstr(is,"XXXXXX");
	if(xs == NULL)	{
		fprintf(stderr,"maketemp <bad template> '%s'\n",is);
		terror(FUBAR);
		}
/**/
	if(pid == 0)	pid = getpid() & 077777;
/**/
	do	{
		cc = islower(cc) ? cc : 'a';
		sprintf(id,"%0.5d%c",pid,cc);
		if(cc++ >= 'z')	{
			pid += 1;
			cc = 'a';
			}
		strcpy(ws,is);
		xs = strstr(ws,"XXXXXX");
		strncpy(xs,id,6);
		}	while(access(ws,0) == 0);
/**/
	strcpy(is,ws);
/**/
	return(is);
}
FILE	*
xfclose(fp)
FILE	*fp;
{
	if(fp != (FILE *) NULL)	fclose(fp);
	return( (FILE *) NULL );
}
char	*
strstr(os,is)	/* does _is occur in _os literally */
char	*os;
char	*is;
{
	register		char	*osx = os;
	register		int		lsx = strlen(is);
	while(*osx != ZERO)
	if(*osx != *is)					++osx;
	else
	if(strncmp(osx,is,lsx) == 0)	return(osx);
	else							++osx;
	return(NULL);
}
FILE	*
opentmp(fn,mo,td,pa)
char	*fn;	/* resulting name */
char	*mo;	/* mode */
char	*td;	/* temporary directory */
char	*pa;	/* pattern (matrix) for name */
{
	auto	FILE	*fp;
	strcpy(fn,td);
	strcat(fn,"/");
	strcat(fn,pa);
	maketemp(fn);
	fp = efopen(fn,mo,"opentmp");
	if(fp == (FILE *) NULL)	terror(FUBAR);
	return(fp);
}
unhinge(is)		/* unlink with error message */
char	*is;
{
	auto	int		err;
	if(err = unlink(is))	{
		where("unhinge");
		perror(is);
		}
	return(err);
}
